???File Path
==========
***...\Models\travel\TargetModels.cs


// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@@@  SetTarget  @@@@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
public class MdlSetTarget : MdlUserAction {

	public long binSetTargetId { get; set; } = 0;
	
	public short sinTargetType { get; set; } = 1;
	public long? binAccountId { get; set; } = null;
	public long? binCounterStaffId { get; set; } = null;
	public long? binBranchId { get; set; } = null;
	public long? binAirlineMasterId { get; set; } = null;
	public long? binHotelMasterId { get; set; } = null;
	
	[Required()]
	[Display(Name = "Financial Year")]
	public long binFinancialYearId { get; set; } = 0;
	
	public double dblRevenueTarget { get; set; } = 0.0;
	[StringLength(250)]
	public string strRevenueTargetBasedOn { get; set; } = "";
	public double dblYieldTarget { get; set; } = 0.0;
	[StringLength(250)]
	public string strYieldTargetBasedOn { get; set; } = "";
	
	public long[] arlConsiderFkBranchIds { get; set; } = Array.Empty<long>();
	public string strDbArlConsiderFkBranchIds { get; set; } = "";
	public long[] arlConsiderFkServiceIds { get; set; } = Array.Empty<long>();
	public string strDbArlConsiderFkServiceIds { get; set; } = "";
	public long[] arlFkPackageCategoryIds { get; set; } = Array.Empty<long>();
	public string strDbArlFkPackageCategoryIds { get; set; } = "";
	
	public short sinLessRefund { get; set; } = 1;
	
	public short sinSplitupType { get; set; } = 1;
	public short sinMonthWiseSplitup { get; set; } = 1;
	
}

public class MdlReqSetTarget : MdlRequest {

	public MdlSetTarget mdlSetTarget { get; set; } = new MdlSetTarget();
}

public class MdlResSetTarget : MdlResponse {

	public MdlSetTarget mdlSetTarget { get; set; } = new MdlSetTarget();
}

public class MdlResSetTargetList : MdlResponse {

	public List<MdlSetTarget> lstMdlSetTarget { get; set; } = new List<MdlSetTarget>();
}

public class MdlResSetTargetInit : MdlResponse {
	public List<MdlBaseIntId> lstMdlAccountBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlCounterStaffBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlBranchBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlAirlineMasterBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlHotelMasterBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlFinancialYearBaseIntId { get; set; } = new List<MdlBaseIntId>();


	public List<MdlSetTarget> lstMdlSetTarget { get; set; } = new List<MdlSetTarget>();
}

