-- @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
--   TARGET->TBL_SET_TARGET_SPLITUP TBL_SET_TARGET_SPLITUP TBL_SET_TARGET_SPLITUP TBL_SET_TARGET_SPLITUP  
-- @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
------------------------------------------------------------------------------------------
            CREATE OR REPLACE FUNCTION fn_get_all_set_target_splitup() RETURNS SETOF target.tbl_set_target_splitup AS $$
                DECLARE

                BEGIN
                    RETURN QUERY SELECT * FROM target.tbl_set_target_splitup WHERE int_sys_action_id != -1;  
                END;
            $$ LANGUAGE plpgsql;
        

------------------------------------------------------------------------------------------
            CREATE OR REPLACE FUNCTION fn_get_all_set_target_splitup_with_action_user() 
                            RETURNS TABLE (pk_set_target_splitup_id BIGINT,
								fk_set_target_id BIGINT,

								fk_service_id BIGINT,
								fk_service_grouping_id BIGINT,
								sin_service_grouping_sys_type SMALLINT,
								sin_month SMALLINT,

								dbl_revenue_target_perc DOUBLE PRECISION,
								dbl_revenue_target DOUBLE PRECISION,
								dbl_yield_target_perc DOUBLE PRECISION,
								dbl_yield_target DOUBLE PRECISION) AS $$
                DECLARE

                BEGIN
                    RETURN QUERY SELECT mt.pk_set_target_splitup_id,
					mt.fk_set_target_id,

					mt.fk_service_id,
					mt.fk_service_grouping_id,
					mt.sin_service_grouping_sys_type,
					mt.sin_month,

					mt.dbl_revenue_target_perc,
					mt.dbl_revenue_target,
					mt.dbl_yield_target_perc,
					mt.dbl_yield_target
                        FROM target.tbl_set_target_splitup mt 
                            LEFT JOIN authentication.tbl_user u1
                                ON mt.fk_created_user_id =  u1.pk_user_id
                            LEFT JOIN authentication.tbl_user u2
                                ON mt.fk_last_modified_user_id =  u2.pk_user_id
                            LEFT JOIN authentication.tbl_user u3
                                ON mt.fk_deleted_user_id =  u3.pk_user_id
                        WHERE mt.int_sys_action_id != -1  
                        ORDER BY ;
                END;
            $$ LANGUAGE plpgsql;
        

------------------------------------------------------------------------------------------

            CREATE OR REPLACE PROCEDURE sp_insert_or_update_set_target_splitup(jsnSetTargetSplitup JSONB, jsnSqlRes OUT JSON) AS $$
                DECLARE
                    objSpOutRes TYP_SP_OUT_RES;
                    objFnCheckRes TYP_FN_CHECK_RES;
                    dtmCurrent TIMESTAMP WITH TIME ZONE;
                BEGIN
                    SELECT NOW() INTO dtmCurrent;

                    -- // Duplication Checking in DB FUCTION(Insert and Update)
                    SELECT * FROM  fn_check_data_uniqueness('target.tbl_set_target_splitup'::VARCHAR, ''::VARCHAR, ::VARCHAR, 'pk_set_target_splitup_id'::VARCHAR, CAST(jsnSetTargetSplitup->>'binSetTargetSplitupId' AS BIGINT)::BIGINT) INTO objFnCheckRes;
                    IF objFnCheckRes.sin_sql_check_status = -1::SMALLINT THEN
                        objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                        objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                        objSpOutRes.strSqlCustomMessage := objFnCheckRes.vhr_sql_check_message;

                        objSpOutRes.strSqlCustomErrorType := 'DATABASE_VALIDATION_ERROR';

                        SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                        RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                        RETURN;
                    END IF;

                    IF CAST(jsnSetTargetSplitup->>'binSetTargetSplitupId' AS BIGINT)::BIGINT = 0::BIGINT THEN
                        -- // Count Exced or other checking License related in DB FUCTION(Insert)
                        

                        --jsnSetTargetSplitup.intSysActionId = 0;
                        --jsnSetTargetSplitup.binCreatedUserId = jsnSetTargetSplitup.linLoginUserId;
                        --jsnSetTargetSplitup.dtmCreated = jsnSetTargetSplitup.dtmCurrentDateTime; --SELECT NOW();

                        INSERT INTO target.tbl_set_target_splitup (fk_set_target_id,

						fk_service_id,
						fk_service_grouping_id,
						sin_service_grouping_sys_type,
						sin_month,

						dbl_revenue_target_perc,
						dbl_revenue_target,
						dbl_yield_target_perc,
						dbl_yield_target)
                            VALUES(CAST(jsnSetTargetSplitup->>'binSetTargetId' AS BIGINT),

						CAST(jsnSetTargetSplitup->>'binServiceId' AS BIGINT),
						CAST(jsnSetTargetSplitup->>'binServiceGroupingId' AS BIGINT),
						CAST(jsnSetTargetSplitup->>'sinServiceGroupingSysType' AS SMALLINT),
						CAST(jsnSetTargetSplitup->>'sinMonth' AS SMALLINT),

						CAST(jsnSetTargetSplitup->>'dblRevenueTargetPerc' AS DOUBLE PRECISION),
						CAST(jsnSetTargetSplitup->>'dblRevenueTarget' AS DOUBLE PRECISION),
						CAST(jsnSetTargetSplitup->>'dblYieldTargetPerc' AS DOUBLE PRECISION),
						CAST(jsnSetTargetSplitup->>'dblYieldTarget' AS DOUBLE PRECISION)) RETURNING pk_set_target_splitup_id INTO objSpOutRes.binSqlPk;
                    ELSE
                        -- // UPDATE Check already update another usersin DB FUCTION(Update and Delete)
                        SELECT * FROM  fn_check_already_update_or_delete_another_user('target.tbl_set_target_splitup'::VARCHAR, 'pk_set_target_splitup_id'::VARCHAR, CAST(jsnSetTargetSplitup->>'binSetTargetSplitupId' AS BIGINT)::BIGINT, CAST(jsnSetTargetSplitup->>'intSysActionId' AS INT)::INT) INTO objFnCheckRes;
                        IF objFnCheckRes.sin_sql_check_status = -1::SMALLINT THEN
                            objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                            objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                            objSpOutRes.strSqlCustomMessage := objFnCheckRes.vhr_sql_check_message;

                            objSpOutRes.strSqlCustomErrorType := 'DATABASE_VALIDATION_ERROR';

                            SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                            RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                            RETURN;
                        END IF;

                        --jsnSetTargetSplitup.intSysActionId = jsnSetTargetSplitup.intSysActionId + 1;
                        --jsnSetTargetSplitup.binLastModifiedUserId = jsnSetTargetSplitup.linLoginUserId;
                        --jsnSetTargetSplitup.dtmLastModified = jsnSetTargetSplitup.dtmCurrentDateTime; --SELECT NOW();

                        UPDATE target.tbl_set_target_splitup SET fk_set_target_id = CAST(jsnSetTargetSplitup->>'binSetTargetId' AS BIGINT),

						fk_service_id = CAST(jsnSetTargetSplitup->>'binServiceId' AS BIGINT),
						fk_service_grouping_id = CAST(jsnSetTargetSplitup->>'binServiceGroupingId' AS BIGINT),
						sin_service_grouping_sys_type = CAST(jsnSetTargetSplitup->>'sinServiceGroupingSysType' AS SMALLINT),
						sin_month = CAST(jsnSetTargetSplitup->>'sinMonth' AS SMALLINT),

						dbl_revenue_target_perc = CAST(jsnSetTargetSplitup->>'dblRevenueTargetPerc' AS DOUBLE PRECISION),
						dbl_revenue_target = CAST(jsnSetTargetSplitup->>'dblRevenueTarget' AS DOUBLE PRECISION),
						dbl_yield_target_perc = CAST(jsnSetTargetSplitup->>'dblYieldTargetPerc' AS DOUBLE PRECISION),
						dbl_yield_target = CAST(jsnSetTargetSplitup->>'dblYieldTarget' AS DOUBLE PRECISION) 
                        WHERE pk_set_target_splitup_id = CAST(jsnSetTargetSplitup->>'binSetTargetSplitupId' AS BIGINT);
                    END IF;

                    --COMMIT;
                    objSpOutRes.sinSqlCustomStatus := 1::SMALLINT;
                    objSpOutRes.strSqlCustomStatusCode := 'SUCCESS';
                    objSpOutRes.strSqlCustomMessage := 'SetTargetSplitup Saved';
                    objSpOutRes.dtmCurrent = dtmCurrent;
                    
                    SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                    RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                    RETURN;
                EXCEPTION WHEN OTHERS THEN
                    ROLLBACK;
                    objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                    objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                    objSpOutRes.strSqlCustomMessage := 'SetTargetSplitup Save Failed';

                    objSpOutRes.strSqlCustomErrorType := 'DATABASE_SYSTEM_ERROR';

                    GET STACKED DIAGNOSTICS 
				        objSpOutRes.strSqlSysMessage := MESSAGE_TEXT,
                    	objSpOutRes.strSqlSysExceptionDetail := PG_EXCEPTION_DETAIL,
                    	objSpOutRes.strSqlSysExceptionHint := PG_EXCEPTION_CONTEXT;
                
                    SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                    RAISE EXCEPTION 'jsnSqlRes: %', jsnSqlRes;
                    RETURN;
                END;
            $$ LANGUAGE plpgsql;
        

------------------------------------------------------------------------------------------

            CREATE OR REPLACE PROCEDURE sp_delete_set_target_splitup(binSetTargetSplitupId BIGINT, intSysActionId INT, binDeletedUserId BIGINT, jsnSqlRes OUT JSON) AS $$
                DECLARE
                    objSpOutRes TYP_SP_OUT_RES;
                    objFnCheckRes TYP_FN_CHECK_RES;
                    dtmCurrent TIMESTAMP WITH TIME ZONE;
                BEGIN
                    SELECT NOW() INTO dtmCurrent;

                    -- // FOREIGN KEY REFERENCES Checking in DB FUCTION(Delete)
                    SELECT * FROM  fn_check_foreignkey_referance('tbl_set_target_splitup'::VARCHAR, 'pk_set_target_splitup_id'::VARCHAR, binSetTargetSplitupId::BIGINT, '{}'::VARCHAR ARRAY) INTO objFnCheckRes;
                    IF objFnCheckRes.sin_sql_check_status = -1::SMALLINT THEN
                        objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                        objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                        objSpOutRes.strSqlCustomMessage := objFnCheckRes.vhr_sql_check_message;

                        objSpOutRes.strSqlCustomErrorType := 'DATABASE_VALIDATION_ERROR';

                        SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                        RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                        RETURN;
                    END IF;

                    -- // UPDATE Check already update another users in DB FUCTION(Update and Delete)
                    SELECT * FROM  fn_check_already_update_or_delete_another_user('target.tbl_set_target_splitup'::VARCHAR, 'pk_set_target_splitup_id'::VARCHAR, CAST(binSetTargetSplitupId AS BIGINT)::BIGINT, intSysActionId::INT) INTO objFnCheckRes;
                    IF objFnCheckRes.sin_sql_check_status = -1::SMALLINT THEN
                        objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                        objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                        objSpOutRes.strSqlCustomMessage := objFnCheckRes.vhr_sql_check_message;

                        objSpOutRes.strSqlCustomErrorType := 'DATABASE_VALIDATION_ERROR';

                        SELECT * FROM  fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                        RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                        RETURN;
                    END IF;

                    --dtmDeleted = SELECT NOW();
                    UPDATE target.tbl_set_target_splitup SET int_sys_action_id = -1::INT,
                                fk_deleted_user_id = binDeletedUserId,
                                dtm_deleted = dtmCurrent
                        WHERE pk_set_target_splitup_id = binSetTargetSplitupId;

                    --COMMIT;
                    objSpOutRes.sinSqlCustomStatus := 1::SMALLINT;
                    objSpOutRes.strSqlCustomStatusCode := 'SUCCESS';
                    objSpOutRes.strSqlCustomMessage := 'SetTargetSplitup Deleted';
                    objSpOutRes.dtmCurrent = dtmCurrent;

                    SELECT * FROM fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                    RAISE NOTICE 'jsnSqlRes: %', jsnSqlRes;
                    RETURN;
                EXCEPTION WHEN OTHERS THEN
                    ROLLBACK;
                    objSpOutRes.sinSqlCustomStatus := -1::SMALLINT;
                    objSpOutRes.strSqlCustomStatusCode := 'ERROR';
                    objSpOutRes.strSqlCustomMessage := 'SetTargetSplitup Delete Failed';

                    objSpOutRes.strSqlCustomErrorType := 'DATABASE_SYSTEM_ERROR';

                    GET STACKED DIAGNOSTICS 
				        objSpOutRes.strSqlSysMessage := MESSAGE_TEXT,
                    	objSpOutRes.strSqlSysExceptionDetail := PG_EXCEPTION_DETAIL,
                    	objSpOutRes.strSqlSysExceptionHint := PG_EXCEPTION_CONTEXT;

                    SELECT * FROM fn_convert_type_out_object_to_out_json(objSpOutRes) INTO jsnSqlRes;
                    RAISE EXCEPTION 'jsnSqlRes: %', jsnSqlRes;
                    RETURN;
                END;
            $$ LANGUAGE plpgsql;
        

